import { writable } from 'svelte/store';
import { browser } from '$app/environment';

function localStorageStore(storageKey, defaultValue = null) {
    if (!browser) return defaultValue;
    let value = window.localStorage.getItem(storageKey);
    if (value === null) {
        if (defaultValue !== null) window.localStorage.setItem(storageKey, defaultValue);
        value = defaultValue;
    }
    return writable(value)
}

export const postSearchResults = writable(null);
export const loading = writable(false);
export const lastSearch = localStorageStore('lastSearch', '');
export const showSearch = writable(true);
export const imageGridColumns = localStorageStore('gridColumns', 6);
export const postGridPreviewQuality = localStorageStore('gridPreviewQuality', 'preview');
export const blacklist = localStorageStore('blacklist', ['gore', 'scat'])

export const limitImageHeight = localStorageStore('limitImageHeight', false)